/**@file
  Header file for the AUNIT Pnp Settings
  
 @copyright
  INTEL CONFIDENTIAL
  Copyright 2012 - 2017 Intel Corporation.

  The source code contained or described herein and all documents related to the
  source code ("Material") are owned by Intel Corporation or its suppliers or
  licensors. Title to the Material remains with Intel Corporation or its suppliers
  and licensors. The Material may contain trade secrets and proprietary and
  confidential information of Intel Corporation and its suppliers and licensors,
  and is protected by worldwide copyright and trade secret laws and treaty
  provisions. No part of the Material may be used, copied, reproduced, modified,
  published, uploaded, posted, transmitted, distributed, or disclosed in any way
  without Intel's prior express written permission.

  No license under any patent, copyright, trade secret or other intellectual
  property right is granted to or conferred upon you by disclosure or delivery
  of the Materials, either expressly, by implication, inducement, estoppel or
  otherwise. Any license under such intellectual property rights must be
  express and approved by Intel in writing.

  Unless otherwise agreed by Intel in writing, you may not remove or alter
  this notice or any other notice embedded in Materials by Intel or
  Intel's suppliers or licensors in any way.

  This file contains a 'Sample Driver' and is licensed as such under the terms
  of your license agreement with Intel or your vendor. This file may be modified
  by the user, subject to the additional terms of the license agreement.

@par Specification
**/

#ifndef AUNIT_BIOS_SETTINGS_HH
#define AUNIT_BIOS_SETTINGS_HH

#define AUNIT_VALUEFORPERF_MSG_VALUES_PLATFORM_DEFAULT \
/*  MsgPort,    Offset, MSB, LSB, Value */  \
    {0x4d, 0x6430,   7,   0, 0x1},  /* A_CR_CRDARB_GCNT_DEV_P_0_MCHBAR.CHID0 */ \
    {0x4d, 0x6430,  15,   8, 0x1},  /* A_CR_CRDARB_GCNT_DEV_P_0_MCHBAR.CHID1 */ \
    {0x4d, 0x6430,  23,  16, 0x0},  /* A_CR_CRDARB_GCNT_DEV_P_0_MCHBAR.CHID2 */ \
    {0x4d, 0x6430,  31,  24, 0x1},  /* A_CR_CRDARB_GCNT_DEV_P_0_MCHBAR.CHID3 */ \
    {0x4d, 0x6434,   7,   0, 0x0},  /* A_CR_CRDARB_GCNT_DEV_P_1_MCHBAR.CHID4 */ \
    {0x4d, 0x6434,  15,   8, 0x1},  /* A_CR_CRDARB_GCNT_DEV_P_1_MCHBAR.CHID5 */ \
    {0x4d, 0x6434,  23,  16, 0x1},  /* A_CR_CRDARB_GCNT_DEV_P_1_MCHBAR.CHID6 */ \
    {0x4d, 0x6434,  31,  24, 0x1},  /* A_CR_CRDARB_GCNT_DEV_P_1_MCHBAR.CHID7 */ \
    {0x4d, 0x6438,   7,   0, 0x1},  /* A_CR_CRDARB_GCNT_DEV_N_0_MCHBAR.CHID0 */ \
    {0x4d, 0x6438,  15,   8, 0x1},  /* A_CR_CRDARB_GCNT_DEV_N_0_MCHBAR.CHID1 */ \
    {0x4d, 0x6438,  23,  16, 0x1},  /* A_CR_CRDARB_GCNT_DEV_N_0_MCHBAR.CHID2 */ \
    {0x4d, 0x6438,  31,  24, 0x1},  /* A_CR_CRDARB_GCNT_DEV_N_0_MCHBAR.CHID3 */ \
    {0x4d, 0x643c,   7,   0, 0x1},  /* A_CR_CRDARB_GCNT_DEV_N_1_MCHBAR.CHID4 */ \
    {0x4d, 0x643c,  15,   8, 0x1},  /* A_CR_CRDARB_GCNT_DEV_N_1_MCHBAR.CHID5 */ \
    {0x4d, 0x643c,  23,  16, 0x1},  /* A_CR_CRDARB_GCNT_DEV_N_1_MCHBAR.CHID6 */ \
    {0x4d, 0x643c,  31,  24, 0x1},  /* A_CR_CRDARB_GCNT_DEV_N_1_MCHBAR.CHID7 */ \
    {0x4d, 0x6440,   7,   0, 0x1},  /* A_CR_CRDARB_GCNT_DEV_C_0_MCHBAR.CHID0 */ \
    {0x4d, 0x6440,  15,   8, 0x1},  /* A_CR_CRDARB_GCNT_DEV_C_0_MCHBAR.CHID1 */ \
    {0x4d, 0x6440,  23,  16, 0x0},  /* A_CR_CRDARB_GCNT_DEV_C_0_MCHBAR.CHID2 */ \
    {0x4d, 0x6440,  31,  24, 0x0},  /* A_CR_CRDARB_GCNT_DEV_C_0_MCHBAR.CHID3 */ \
    {0x4d, 0x6444,   7,   0, 0x1},  /* A_CR_CRDARB_GCNT_CLS_MCHBAR.P */ \
    {0x4d, 0x6444,  15,   8, 0x1},  /* A_CR_CRDARB_GCNT_CLS_MCHBAR.NP */ \
    {0x4d, 0x6444,  23,  16, 0x1},  /* A_CR_CRDARB_GCNT_CLS_MCHBAR.C */ \
    {0x4d, 0x6448,   7,   0, 0x8},  /* A_CR_GZLQ_LIMIT_CH0_3_MCHBAR.CHID0 */ \
    {0x4d, 0x6448,  15,   8, 0xff},  /* A_CR_GZLQ_LIMIT_CH0_3_MCHBAR.CHID1 */ \
    {0x4d, 0x6448,  23,  16, 0xff},  /* A_CR_GZLQ_LIMIT_CH0_3_MCHBAR.CHID2 */ \
    {0x4d, 0x6448,  31,  24, 0xff},  /* A_CR_GZLQ_LIMIT_CH0_3_MCHBAR.CHID3 */ \
    {0x4d, 0x644c,   7,   0, 0xff},  /* A_CR_GZLQ_LIMIT_CH4_7_MCHBAR.CHID4 */ \
    {0x4d, 0x644c,  15,   8, 0xff},  /* A_CR_GZLQ_LIMIT_CH4_7_MCHBAR.CHID5 */ \
    {0x4d, 0x644c,  23,  16, 0xff},  /* A_CR_GZLQ_LIMIT_CH4_7_MCHBAR.CHID6 */ \
    {0x4d, 0x644c,  31,  24, 0xff},  /* A_CR_GZLQ_LIMIT_CH4_7_MCHBAR.CHID7 */ \
    {0x4d, 0x6450,   0,   0, 0x0},  /* A_CR_SLICE_CHANNEL_HASH_0_0_0_MCHBAR.SLICE_1_DISABLED */ \
    {0x4d, 0x6450,   1,   1, 0x0},  /* A_CR_SLICE_CHANNEL_HASH_0_0_0_MCHBAR.HVM_MODE */ \
    {0x4d, 0x6450,   3,   2, 0x2},  /* A_CR_SLICE_CHANNEL_HASH_0_0_0_MCHBAR.INTERLEAVE_MODE */ \
    {0x4d, 0x6450,  19,   6, 0x9},  /* A_CR_SLICE_CHANNEL_HASH_0_0_0_MCHBAR.SLICE_HASH_MASK */ \
    {0x4d, 0x6450,  51,  38, 0x36},  /* A_CR_SLICE_CHANNEL_HASH_0_0_0_MCHBAR.CH_HASH_MASK */ \
    {0x4d, 0x6484,   7,   0, 0xff},  /* A_CR_CHAP_SLCT1_MCHBAR.CHID_X_CNT_UPTXN */ \
    {0x4d, 0x6484,  23,  16, 0xff} /* A_CR_CHAP_SLCT1_MCHBAR.CHID_Y_CNT_UPTXN */ \
/* end of AUNIT_VALUEFORPERF_MSG_VALUES_PLATFORM_DEFAULT */

#define AUNIT_VALUEFORPOWER_MSG_VALUES_PLATFORM_DEFAULT \
/*  MsgPort,    Offset, MSB, LSB, Value */  \
    {0x4d, 0x6430,   7,   0, 0x1},  /* A_CR_CRDARB_GCNT_DEV_P_0_MCHBAR.CHID0 */ \
    {0x4d, 0x6430,  15,   8, 0x1},  /* A_CR_CRDARB_GCNT_DEV_P_0_MCHBAR.CHID1 */ \
    {0x4d, 0x6430,  23,  16, 0x0},  /* A_CR_CRDARB_GCNT_DEV_P_0_MCHBAR.CHID2 */ \
    {0x4d, 0x6430,  31,  24, 0x1},  /* A_CR_CRDARB_GCNT_DEV_P_0_MCHBAR.CHID3 */ \
    {0x4d, 0x6434,   7,   0, 0x0},  /* A_CR_CRDARB_GCNT_DEV_P_1_MCHBAR.CHID4 */ \
    {0x4d, 0x6434,  15,   8, 0x1},  /* A_CR_CRDARB_GCNT_DEV_P_1_MCHBAR.CHID5 */ \
    {0x4d, 0x6434,  23,  16, 0x1},  /* A_CR_CRDARB_GCNT_DEV_P_1_MCHBAR.CHID6 */ \
    {0x4d, 0x6434,  31,  24, 0x1},  /* A_CR_CRDARB_GCNT_DEV_P_1_MCHBAR.CHID7 */ \
    {0x4d, 0x6438,   7,   0, 0x1},  /* A_CR_CRDARB_GCNT_DEV_N_0_MCHBAR.CHID0 */ \
    {0x4d, 0x6438,  15,   8, 0x1},  /* A_CR_CRDARB_GCNT_DEV_N_0_MCHBAR.CHID1 */ \
    {0x4d, 0x6438,  23,  16, 0x1},  /* A_CR_CRDARB_GCNT_DEV_N_0_MCHBAR.CHID2 */ \
    {0x4d, 0x6438,  31,  24, 0x1},  /* A_CR_CRDARB_GCNT_DEV_N_0_MCHBAR.CHID3 */ \
    {0x4d, 0x643c,   7,   0, 0x1},  /* A_CR_CRDARB_GCNT_DEV_N_1_MCHBAR.CHID4 */ \
    {0x4d, 0x643c,  15,   8, 0x1},  /* A_CR_CRDARB_GCNT_DEV_N_1_MCHBAR.CHID5 */ \
    {0x4d, 0x643c,  23,  16, 0x1},  /* A_CR_CRDARB_GCNT_DEV_N_1_MCHBAR.CHID6 */ \
    {0x4d, 0x643c,  31,  24, 0x1},  /* A_CR_CRDARB_GCNT_DEV_N_1_MCHBAR.CHID7 */ \
    {0x4d, 0x6440,   7,   0, 0x1},  /* A_CR_CRDARB_GCNT_DEV_C_0_MCHBAR.CHID0 */ \
    {0x4d, 0x6440,  15,   8, 0x1},  /* A_CR_CRDARB_GCNT_DEV_C_0_MCHBAR.CHID1 */ \
    {0x4d, 0x6440,  23,  16, 0x0},  /* A_CR_CRDARB_GCNT_DEV_C_0_MCHBAR.CHID2 */ \
    {0x4d, 0x6440,  31,  24, 0x0},  /* A_CR_CRDARB_GCNT_DEV_C_0_MCHBAR.CHID3 */ \
    {0x4d, 0x6444,   7,   0, 0x1},  /* A_CR_CRDARB_GCNT_CLS_MCHBAR.P */ \
    {0x4d, 0x6444,  15,   8, 0x1},  /* A_CR_CRDARB_GCNT_CLS_MCHBAR.NP */ \
    {0x4d, 0x6444,  23,  16, 0x1},  /* A_CR_CRDARB_GCNT_CLS_MCHBAR.C */ \
    {0x4d, 0x6448,   7,   0, 0x8},  /* A_CR_GZLQ_LIMIT_CH0_3_MCHBAR.CHID0 */ \
    {0x4d, 0x6448,  15,   8, 0xff},  /* A_CR_GZLQ_LIMIT_CH0_3_MCHBAR.CHID1 */ \
    {0x4d, 0x6448,  23,  16, 0xff},  /* A_CR_GZLQ_LIMIT_CH0_3_MCHBAR.CHID2 */ \
    {0x4d, 0x6448,  31,  24, 0xff},  /* A_CR_GZLQ_LIMIT_CH0_3_MCHBAR.CHID3 */ \
    {0x4d, 0x644c,   7,   0, 0xff},  /* A_CR_GZLQ_LIMIT_CH4_7_MCHBAR.CHID4 */ \
    {0x4d, 0x644c,  15,   8, 0xff},  /* A_CR_GZLQ_LIMIT_CH4_7_MCHBAR.CHID5 */ \
    {0x4d, 0x644c,  23,  16, 0xff},  /* A_CR_GZLQ_LIMIT_CH4_7_MCHBAR.CHID6 */ \
    {0x4d, 0x644c,  31,  24, 0xff},  /* A_CR_GZLQ_LIMIT_CH4_7_MCHBAR.CHID7 */ \
    {0x4d, 0x6450,   0,   0, 0x0},  /* A_CR_SLICE_CHANNEL_HASH_0_0_0_MCHBAR.SLICE_1_DISABLED */ \
    {0x4d, 0x6450,   1,   1, 0x0},  /* A_CR_SLICE_CHANNEL_HASH_0_0_0_MCHBAR.HVM_MODE */ \
    {0x4d, 0x6450,   3,   2, 0x2},  /* A_CR_SLICE_CHANNEL_HASH_0_0_0_MCHBAR.INTERLEAVE_MODE */ \
    {0x4d, 0x6450,  19,   6, 0x9},  /* A_CR_SLICE_CHANNEL_HASH_0_0_0_MCHBAR.SLICE_HASH_MASK */ \
    {0x4d, 0x6450,  51,  38, 0x36},  /* A_CR_SLICE_CHANNEL_HASH_0_0_0_MCHBAR.CH_HASH_MASK */ \
    {0x4d, 0x6484,   7,   0, 0xff},  /* A_CR_CHAP_SLCT1_MCHBAR.CHID_X_CNT_UPTXN */ \
    {0x4d, 0x6484,  23,  16, 0xff} /* A_CR_CHAP_SLCT1_MCHBAR.CHID_Y_CNT_UPTXN */ \
/* end of AUNIT_VALUEFORPOWER_MSG_VALUES_PLATFORM_DEFAULT */

#define AUNIT_VALUEFORPWRPERF_MSG_VALUES_PLATFORM_DEFAULT \
/*  MsgPort,    Offset, MSB, LSB, Value */  \
    {0x4d, 0x6430,   7,   0, 0x1},  /* A_CR_CRDARB_GCNT_DEV_P_0_MCHBAR.CHID0 */ \
    {0x4d, 0x6430,  15,   8, 0x1},  /* A_CR_CRDARB_GCNT_DEV_P_0_MCHBAR.CHID1 */ \
    {0x4d, 0x6430,  23,  16, 0x0},  /* A_CR_CRDARB_GCNT_DEV_P_0_MCHBAR.CHID2 */ \
    {0x4d, 0x6430,  31,  24, 0x1},  /* A_CR_CRDARB_GCNT_DEV_P_0_MCHBAR.CHID3 */ \
    {0x4d, 0x6434,   7,   0, 0x0},  /* A_CR_CRDARB_GCNT_DEV_P_1_MCHBAR.CHID4 */ \
    {0x4d, 0x6434,  15,   8, 0x1},  /* A_CR_CRDARB_GCNT_DEV_P_1_MCHBAR.CHID5 */ \
    {0x4d, 0x6434,  23,  16, 0x1},  /* A_CR_CRDARB_GCNT_DEV_P_1_MCHBAR.CHID6 */ \
    {0x4d, 0x6434,  31,  24, 0x1},  /* A_CR_CRDARB_GCNT_DEV_P_1_MCHBAR.CHID7 */ \
    {0x4d, 0x6438,   7,   0, 0x1},  /* A_CR_CRDARB_GCNT_DEV_N_0_MCHBAR.CHID0 */ \
    {0x4d, 0x6438,  15,   8, 0x1},  /* A_CR_CRDARB_GCNT_DEV_N_0_MCHBAR.CHID1 */ \
    {0x4d, 0x6438,  23,  16, 0x1},  /* A_CR_CRDARB_GCNT_DEV_N_0_MCHBAR.CHID2 */ \
    {0x4d, 0x6438,  31,  24, 0x1},  /* A_CR_CRDARB_GCNT_DEV_N_0_MCHBAR.CHID3 */ \
    {0x4d, 0x643c,   7,   0, 0x1},  /* A_CR_CRDARB_GCNT_DEV_N_1_MCHBAR.CHID4 */ \
    {0x4d, 0x643c,  15,   8, 0x1},  /* A_CR_CRDARB_GCNT_DEV_N_1_MCHBAR.CHID5 */ \
    {0x4d, 0x643c,  23,  16, 0x1},  /* A_CR_CRDARB_GCNT_DEV_N_1_MCHBAR.CHID6 */ \
    {0x4d, 0x643c,  31,  24, 0x1},  /* A_CR_CRDARB_GCNT_DEV_N_1_MCHBAR.CHID7 */ \
    {0x4d, 0x6440,   7,   0, 0x1},  /* A_CR_CRDARB_GCNT_DEV_C_0_MCHBAR.CHID0 */ \
    {0x4d, 0x6440,  15,   8, 0x1},  /* A_CR_CRDARB_GCNT_DEV_C_0_MCHBAR.CHID1 */ \
    {0x4d, 0x6440,  23,  16, 0x0},  /* A_CR_CRDARB_GCNT_DEV_C_0_MCHBAR.CHID2 */ \
    {0x4d, 0x6440,  31,  24, 0x0},  /* A_CR_CRDARB_GCNT_DEV_C_0_MCHBAR.CHID3 */ \
    {0x4d, 0x6444,   7,   0, 0x1},  /* A_CR_CRDARB_GCNT_CLS_MCHBAR.P */ \
    {0x4d, 0x6444,  15,   8, 0x1},  /* A_CR_CRDARB_GCNT_CLS_MCHBAR.NP */ \
    {0x4d, 0x6444,  23,  16, 0x1},  /* A_CR_CRDARB_GCNT_CLS_MCHBAR.C */ \
    {0x4d, 0x6448,   7,   0, 0x8},  /* A_CR_GZLQ_LIMIT_CH0_3_MCHBAR.CHID0 */ \
    {0x4d, 0x6448,  15,   8, 0xff},  /* A_CR_GZLQ_LIMIT_CH0_3_MCHBAR.CHID1 */ \
    {0x4d, 0x6448,  23,  16, 0xff},  /* A_CR_GZLQ_LIMIT_CH0_3_MCHBAR.CHID2 */ \
    {0x4d, 0x6448,  31,  24, 0xff},  /* A_CR_GZLQ_LIMIT_CH0_3_MCHBAR.CHID3 */ \
    {0x4d, 0x644c,   7,   0, 0xff},  /* A_CR_GZLQ_LIMIT_CH4_7_MCHBAR.CHID4 */ \
    {0x4d, 0x644c,  15,   8, 0xff},  /* A_CR_GZLQ_LIMIT_CH4_7_MCHBAR.CHID5 */ \
    {0x4d, 0x644c,  23,  16, 0xff},  /* A_CR_GZLQ_LIMIT_CH4_7_MCHBAR.CHID6 */ \
    {0x4d, 0x644c,  31,  24, 0xff},  /* A_CR_GZLQ_LIMIT_CH4_7_MCHBAR.CHID7 */ \
    {0x4d, 0x6450,   0,   0, 0x0},  /* A_CR_SLICE_CHANNEL_HASH_0_0_0_MCHBAR.SLICE_1_DISABLED */ \
    {0x4d, 0x6450,   1,   1, 0x0},  /* A_CR_SLICE_CHANNEL_HASH_0_0_0_MCHBAR.HVM_MODE */ \
    {0x4d, 0x6450,   3,   2, 0x2},  /* A_CR_SLICE_CHANNEL_HASH_0_0_0_MCHBAR.INTERLEAVE_MODE */ \
    {0x4d, 0x6450,  19,   6, 0x9},  /* A_CR_SLICE_CHANNEL_HASH_0_0_0_MCHBAR.SLICE_HASH_MASK */ \
    {0x4d, 0x6450,  51,  38, 0x36},  /* A_CR_SLICE_CHANNEL_HASH_0_0_0_MCHBAR.CH_HASH_MASK */ \
    {0x4d, 0x6484,   7,   0, 0xff},  /* A_CR_CHAP_SLCT1_MCHBAR.CHID_X_CNT_UPTXN */ \
    {0x4d, 0x6484,  23,  16, 0xff} /* A_CR_CHAP_SLCT1_MCHBAR.CHID_Y_CNT_UPTXN */ \
/* end of AUNIT_VALUEFORPWRPERF_MSG_VALUES_PLATFORM_DEFAULT */

#endif // AUNIT_BIOS_SETTINGS_HH
