/** @file
  File name:    MmrcProjectDataGenerated.h
  Input File:   BXTM_SOC.xlsx

  THIS FILE IS AUTO-GENERATED BY THE MMRC TOOL. DO NOT CHANGE THIS CODE.

  If edits are needed in this file, they must be done via the MMRC tool.

  If there is additional project-specific data required by the MMRC, it
  can be placed in MmrcProjectData.h, which is used for non-tool-generated
  data

  This file contains data structures for a particular piece of silicon.
  These structures are fed to MmrcLibraries.c, which use them to initialize
  memory.

  @copyright
  Copyright (c) 2005-2016 Intel Corporation. All rights reserved
  This software and associated documentation (if any) is furnished
  under a license and may only be used or copied in accordance
  with the terms of the license. Except as permitted by the
  license, no part of this software or documentation may be
  reproduced, stored in a retrieval system, or transmitted in any
  form or by any means without the express written consent of
  Intel Corporation.
  This file contains an 'Intel Peripheral Driver' and is uniquely
  identified as 'Intel Reference Module' and is licensed for Intel
  CPUs and chipsets under the terms of your license agreement with
  Intel or your vendor. This file may be modified by the user, subject
  to additional terms of the license agreement.

  @par Specification
**/
#ifndef _MMRCPROJECTDATAGENERATED_H_
#define _MMRCPROJECTDATAGENERATED_H_

#include "MmrcData.h"

extern char *CapsuleStrings[];
//
// Invalid value for a Blueprint define
//
#define INVALID_BLUEPRINT_DEFINE_VALUE                     0xDEADBEEF
//
// Blueprint project defines for BLUEPRINT_LPDDR3
//
#define ECT_MIN_CMD_BLUEPRINT_LPDDR3                       300 // Range for ECT in percentages of 2x clocks
#define ECT_MAX_CMD_BLUEPRINT_LPDDR3                       500 // Range for ECT in percentages of 2x clocks
#define ECT_STEP_CMD_BLUEPRINT_LPDDR3                      25 // Range for ECT in percentages of 2x clocks
#define ECT_MIN_CTL_BLUEPRINT_LPDDR3                       300 // 
#define ECT_MAX_CTL_BLUEPRINT_LPDDR3                       500 // 
#define ECT_STEP_CTL_BLUEPRINT_LPDDR3                      25 // 
//
// Blueprint project defines for BLUEPRINT_LPDDR4
//
#define ECT_MIN_CMD_BLUEPRINT_LPDDR4                       100 // Range for ECT in percentages of 2x clocks
#define ECT_MAX_CMD_BLUEPRINT_LPDDR4                       500 // Range for ECT in percentages of 2x clocks
#define ECT_STEP_CMD_BLUEPRINT_LPDDR4                      50 // Range for ECT in percentages of 2x clocks
#define ECT_MIN_CTL_BLUEPRINT_LPDDR4                       300 // 
#define ECT_MAX_CTL_BLUEPRINT_LPDDR4                       700 // 
#define ECT_STEP_CTL_BLUEPRINT_LPDDR4                      50 // 

#if MAX_BLUEPRINTS > 1
  extern UINT32 ECT_MIN_CMD_GENERATED[MAX_BLUEPRINTS];
  extern UINT32 ECT_MAX_CMD_GENERATED[MAX_BLUEPRINTS];
  extern UINT32 ECT_STEP_CMD_GENERATED[MAX_BLUEPRINTS];
  extern UINT32 ECT_MIN_CTL_GENERATED[MAX_BLUEPRINTS];
  extern UINT32 ECT_MAX_CTL_GENERATED[MAX_BLUEPRINTS];
  extern UINT32 ECT_STEP_CTL_GENERATED[MAX_BLUEPRINTS];
  #define ECT_MIN_CMD  ECT_MIN_CMD_GENERATED[MrcData->CurrentBlueprint]
  #define ECT_MAX_CMD  ECT_MAX_CMD_GENERATED[MrcData->CurrentBlueprint]
  #define ECT_STEP_CMD ECT_STEP_CMD_GENERATED[MrcData->CurrentBlueprint]
  #define ECT_MIN_CTL  ECT_MIN_CTL_GENERATED[MrcData->CurrentBlueprint]
  #define ECT_MAX_CTL  ECT_MAX_CTL_GENERATED[MrcData->CurrentBlueprint]
  #define ECT_STEP_CTL ECT_STEP_CTL_GENERATED[MrcData->CurrentBlueprint]
#else
  extern UINT32 ECT_MIN_CMD_GENERATED;
  extern UINT32 ECT_MAX_CMD_GENERATED;
  extern UINT32 ECT_STEP_CMD_GENERATED;
  extern UINT32 ECT_MIN_CTL_GENERATED;
  extern UINT32 ECT_MAX_CTL_GENERATED;
  extern UINT32 ECT_STEP_CTL_GENERATED;
  #define ECT_MIN_CMD  ECT_MIN_CMD_GENERATED
  #define ECT_MAX_CMD  ECT_MAX_CMD_GENERATED
  #define ECT_STEP_CMD ECT_STEP_CMD_GENERATED
  #define ECT_MIN_CTL  ECT_MIN_CTL_GENERATED
  #define ECT_MAX_CTL  ECT_MAX_CTL_GENERATED
  #define ECT_STEP_CTL ECT_STEP_CTL_GENERATED
#endif

#endif // _MMRCPROJECTDATAGENERATED_H_
