/** @file
  Private declaration file for SmmHeci2MsgLib

 @copyright
  INTEL CONFIDENTIAL
  Copyright 2017 Intel Corporation.

  The source code contained or described herein and all documents related to the
  source code ("Material") are owned by Intel Corporation or its suppliers or
  licensors. Title to the Material remains with Intel Corporation or its suppliers
  and licensors. The Material may contain trade secrets and proprietary and
  confidential information of Intel Corporation and its suppliers and licensors,
  and is protected by worldwide copyright and trade secret laws and treaty
  provisions. No part of the Material may be used, copied, reproduced, modified,
  published, uploaded, posted, transmitted, distributed, or disclosed in any way
  without Intel's prior express written permission.

  No license under any patent, copyright, trade secret or other intellectual
  property right is granted to or conferred upon you by disclosure or delivery
  of the Materials, either expressly, by implication, inducement, estoppel or
  otherwise. Any license under such intellectual property rights must be
  express and approved by Intel in writing.

  Unless otherwise agreed by Intel in writing, you may not remove or alter
  this notice or any other notice embedded in Materials by Intel or
  Intel's suppliers or licensors in any way.

  This file contains an 'Intel Peripheral Driver' and is uniquely identified as
  "Intel Reference Module" and is licensed for Intel CPUs and chipsets under
  the terms of your license agreement with Intel or your vendor. This file may
  be modified by the user, subject to additional terms of the license agreement.

@par Specification Reference

**/

#ifndef _SMM_HECI2_MSG_LIB_H_
#define _SMM_HECI2_MSG_LIB_H_

#include <Uefi.h>
#include <Protocol/Heci.h>
#include <Protocol/SmmPeriodicTimerDispatch2.h>

typedef struct {
  CONST CHAR8              *FileName;
        UINT32             Offset;
  CONST UINT8              *Data;
        UINTN              DataSize;
        BOOLEAN            Truncate;
  CONST EFI_HECI_PROTOCOL  *Heci2Protocol;
        INTN               RemainingDataSize;
} HECI2_NVM_FILE_CONTEXT;

typedef struct _HECI2_COMMAND_QUEUE_CONTEXT {
  UINT8    *CommandQueueBuffer;
  UINTN    CommandQueueBufferSize;
  UINT8    *CommandQueueVerificationBuffer;
  UINTN    CommandQueueVerificationBufferSize;
  UINTN    CommandQueueCount;
} HECI2_COMMAND_QUEUE_CONTEXT;

typedef struct _HECI2_PERIODIC_SMI_CONTEXT {
  BOOLEAN                                  WaitingForHeciReceive;
  EFI_SMM_PERIODIC_TIMER_REGISTER_CONTEXT  RegisterContext;
} HECI2_PERIODIC_SMI_CONTEXT;

#endif
